#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n,k;
    cin>>n>>k;
    long long d;
    long long res1=0;
    long long res2=0;
    for(int i=0;i<k;i++){
        cin>>d;
        res2=0;
        res1=0;
        for(int j=1;j<=d/2;j++){
            if(d%j==0){
                
                res1=j^res1;
                
                
            }
 
          
        }
        //cout<<res2<<endl;
       // cout<<d<<endl;
        res1=d^res1;
       cout<<res1;
       cout<<" ";

        //cout<<"da"<<endl;
    }
    return 0;
}